/* Simple CGI C-program by Johan Adolfsson <Johan.Adolfsson@axis.com>
*! $Id: ccgitest.c,v 1.2 2000-03-03 15:58:57 johana Exp $
*!
*! This file is distributed under the Gnu Public License (GPL),
*! please see the file LICENSE for further information.
*! 
*! ---------------------------------------------------------------------------
*! (C) Copyright 2000, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

extern char **environ;

int debug = 0;
int show_env = 0;


int main(int argc, char **argv)
{
  int i;
  const char *method;
  const char *query;
  const char *uri;

  method = getenv("REQUEST_METHOD");
  query = getenv("QUERY_STRING");
  uri = getenv("REQUEST_URI");

  if (method == NULL)
  {
    /* Not a CGI! */
    printf("This program should be run as a CGI from the web server!\n");
    exit(1);
  }
  /* Print mandatory Content-Type */
  printf("Content-Type: text/html\n\n");

  /* Print body */
  printf("<html><body>\n");

  printf("<pre>\n");
  
  printf("This is a test CGI program, compile it on the webserver (wwwint)\n "
         "and rename the output file to ccgitest.cgi\n");



  if (debug)
  {
    /* Important ENV variables */
    printf("Important ENV:\n");
    printf("method: %s\n", method);
    printf("query: %s\n", query);
    printf("uri: %s\n", uri);    
  }
  
  if (show_env)
  {
    printf("ENV:\n");  
    i=0;
    while (environ[i] != NULL)
    {
      printf("%s\n", environ[i]);
      i++;
      
    }
    printf("</pre>\n");
  }
  
  if (strcmp(method, "GET") == 0)
  {
    printf("GET!");
    printf("<form method=\"POST\">\n"
           "Test 1: <input type=\"text\" name=\"test1\" value=\"test1 value\"><br>\n"
           "Test 2: <input type=\"text\" name=\"test2\" value=\"test2 value\"><br>\n"
           "<input type=submit value=\"Submit\">\n"
           "</form><br>\n");
  }
#if 1
  else if (strcmp(method, "POST") == 0)
  {
    unsigned long content_length = 0;
    ssize_t len = 0;
    ssize_t tmp_len = 0;    
    const char *s;
    char* body;
    
    printf("POST");
    s = getenv("CONTENT_LENGTH");
    content_length= atol(s);
    printf("Content-Length: %lu\n", content_length);
    body = malloc(content_length + 1);
    while (len < content_length)
    {
      printf("Read body\n");
      tmp_len = read(fileno(stdin), &body[len], content_length-len);
      if (tmp_len == -1)
      {
        perror("read stdin:");
      }
      
      len += tmp_len;
      printf("len: %i tmp_len: %i\n", len, tmp_len);
      
    }
    body[content_length] = '\0';
    printf("BODY:\n<pre>%s</pre>\n", body);
  }
#endif  
  else
  {
    printf("Unhandled method: %s\n", method);
  }
  
  printf("</body></html>\n");

  return 0;
}
